<?php

class Maileditor extends Module
{
	/** @var max image size */
	protected $maxImageSize = 307200;

	function __construct()
	{
		$this->name = 'maileditor';
		$this->tab = 'administration';
		$this->version = '2.28a';
		
		parent::__construct();
		
		$this->displayName = $this->l('Mail Template Editor');
		$this->description = $this->l('This module lets you view and edit any existing email templates present in your shop (in both formats: HTML and TXT). It is now fully compatible with Prestashop 1.4.4.<br>The HTML files are edited using the embedded <i>rich text editor</i>, meanwhile the TXT files are edited in a standard <i>plain text editor</i>.<br><br><b><u>Module History:</b></u><br>&bull; Last Updated by <strong>Julio Marchi</strong> (www.friendlyground.com/user/jcmarchi) in August 19, 2011.<br>&bull; Resurrected by <b>Caleydon</b> on August 1st, 2011.<br>&bull; Originally published by <b>Galtech Solutions</b> in September of 2009.');
	}

	function install()
	{
		if (!parent::install())
			return false;
		return $this->registerHook('top');
	}
    function putContents()
    {
        $languages = Language::getLanguages();
        foreach ($languages as $language)
        {
            $this->_putMailFileContents( $language ) ;
        }
    }
	function getContent()
	{

		/* display the module name */
		$this->_html = '<h2>'.$this->displayName.'</h2>';
		$errors = '';

		/* update the editorial xml */
		if (isset($_POST['submitUpdate']))
		{
			// Forbidden key
            $this->putContents() ;
		}

		/* display the editorial's form */
		$this->_html .= $this->_displayForm();
	
		return $this->_html;
	}
    private function _displayMailTemplates()
    {
		/* Languages preliminaries */
		$defaultLanguage = intval(Configuration::get('PS_LANG_DEFAULT'));
		$languages = Language::getLanguages();
		$iso = Language::getIsoById($defaultLanguage);

        $dir = dirname(__FILE__) . "/../../mails/". $iso . "/" ;
        $files = scandir( $dir ) ;
        $cnt = count($files) ;
        $html = '		<a name="emailtemplatelist"></a>
			<form method="post" action="'.$_SERVER['REQUEST_URI'].'" >
			<fieldset style="width: 900px;">
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" /> '.$this->displayName.'</legend>
				<!-- <label>'.$this->l('Existing Mail Templates').'</label><br/><br/><br/> -->' ;
        $html .= '<div style="float:left; margin-left:15px;">
				  <table class="table" style="width:260px;background-color: #fff;">
                    <th>Templates in TXT format</th><th align="center">Edit</th>';

        $tokenModules = $_REQUEST['token'] ;//Tools::getAdminToken('AdminModules'.intval(Tab::getIdFromClassName('AdminModules')).intval($cookie->id_employee));

        for( $i = 0; $i < $cnt; $i ++ )
        {
            if( preg_match('/.txt$/', $files[$i]) )
            {
                $link = '<a href="index.php?tab=AdminModules&token=' . $tokenModules . '&configure=' . urlencode($this->name) . '&file='.$files[$i].'&t=1#emaileditor">' ;
                $link .= '<img src="' . __PS_BASE_URI__ . 'img/admin/edit.gif" /></a>' ;

                $html .= '<tr>
                        <td>'. $files[$i] . '</td>
                        <td align="center">'.$link.'</td>
                      </tr>' ;
            }
        }
        $html .= '</table>' ;
        $html .= '</div>' ;

        $html .= '<div style="float:left; margin-left:15px;">
				  <table class="table" style="width:260px;background-color: #fff;">
                    <th>Templates in HTML format</th><th align="center">Edit</th>';

        $tokenModules = $_REQUEST['token'] ;//Tools::getAdminToken('AdminModules'.intval(Tab::getIdFromClassName('AdminModules')).intval($cookie->id_employee));

        for( $i = 0; $i < $cnt; $i ++ )
        {
            if( preg_match('/.html$/', $files[$i]) )
            {
                $link = '<a href="index.php?tab=AdminModules&token=' . $tokenModules . '&configure=' . urlencode($this->name) . '&file='.$files[$i].'#emaileditor">' ;
                $link .= '<img src="' . __PS_BASE_URI__ . 'img/admin/edit.gif" /></a>' ;

                $html .= '<tr>
                        <td>'. $files[$i] . '</td>
                        <td align="center">'.$link.'</td>
                      </tr>' ;
            }
        }
        $html .= '</table>' ;
        $html .= '</div>' ;

$html .= '
<div style="float:left; margin-left:20px;">
<table width="310" border="0" cellpadding="3" cellspacing="0" style="font-family: Verdana, Geneva, sans-serif; font-size:10px; border:#000 solid 2px; font-weight: normal; background-color:#FFF;">
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#000; "><strong>General Variable (valid in most forms)</strong></td>
  </tr>
  <tr>
    <td width="12" valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td width="100" valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{firstname}</td>
    <td width="202" valign="top" style="border-bottom: solid 1px #000;">User first name</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{lastname}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">User last name</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{shop_name}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Your shop name</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{shop_url}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Your shop URL</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{email}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">User email</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{passwd}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">User password</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{message}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Email message</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{employee}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Employee name</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Order Details</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{id_order}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Order ID number</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{total_paid}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Total paid</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{order_name}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Order name</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{date}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Date order was placed</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{payment}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Payment mode</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{total_products}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Products</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{total_discounts}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Discounts</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{total_shipping}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Shipping</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{total_wrapping}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Gift-wrapping</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Shipping</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{followup}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Package track link</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{carrier}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Carrier</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{delivery_block_txt}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Delivery address</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{invoice_block_txt}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Billing address</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Return</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{id_order_return}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Your return order</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{state_order_return}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Return order status</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Virtual Products</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{nbProducts}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Number of Virtual Products</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{virtualProducts}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Links to all virtual products (for download)</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Voucher</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{voucher_num}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Voucher number</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{voucher_amount}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Voucher value</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Bank Wire</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{bankwire_owner}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Account owner</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{bankwire_details}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Account details</td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000;font-weight: bold;">{bankwire_address}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Bank address</td>
  </tr>
  <tr>
    <td colspan="3" valign="top" style="font-size:12px; color:#FFF; background-color:#999; "><strong>Cheque</strong></td>
  </tr>
  <tr>
    <td valign="top" style="border-bottom: solid 1px #000;">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="border-bottom: solid 1px #000; font-weight: bold;">{cheque_name}</td>
    <td valign="top" style="border-bottom: solid 1px #000;">Name on the check</td>
  </tr>
  <tr>
    <td valign="top">&nbsp;</td>
    <td valign="top" nowrap="nowrap" style="font-weight: bold">{cheque_address}</td>
    <td valign="top">Address for the check</td>
  </tr>
</table>
<div style="font-size:12px; padding-top:4px; color: red; "><strong>IMPORTANT:</strong> Not all possible variables are listed here.</div>
</div>' ;

        $html .= '</fieldset>' ;
        $html .= '</form>' ;
        return $html ;
    }
	private function _displayForm()
	{
        $html = $this->_displayMailTemplates() ;

        if( !isset($_REQUEST['file']) )
        {
            return $html ;
        }
		
        if(isset($_REQUEST['t'])) { $editortype="txt"; } else { $editortype="rte"; } 
		
		global $cookie;
		
		/* Languages preliminaries */
		$isoTinyMCE = (file_exists(_PS_ROOT_DIR_.'/js/tiny_mce/langs/'.$iso.'.js') ? $iso : 'en');
		$ad = dirname($_SERVER["PHP_SELF"]);
		
		$defaultLanguage = intval(Configuration::get('PS_LANG_DEFAULT'));
		$languages = Language::getLanguages();
		$iso = Language::getIsoById((int)($cookie->id_lang));
		$divLangName = 'cpara';

		$html .= '
			<script type="text/javascript">	
			var iso = \''.$isoTinyMCE.'\' ;
			var pathCSS = \''._THEME_CSS_DIR_.'\' ;
			var ad = \''.$ad.'\' ;
			</script>
			<script type="text/javascript" src="'.__PS_BASE_URI__.'js/tiny_mce/tiny_mce.js"></script>
			<script type="text/javascript" src="'.__PS_BASE_URI__.'js/tinymce.inc.js"></script>

		</script>
		<script type="text/javascript">id_language = Number('.$defaultLanguage.');</script>
		<p>&nbsp;</p>
		<a name="emaileditor"></a>
		<form method="post" action="'.$_SERVER['REQUEST_URI'].'">
			<fieldset style="width: 900px;">
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />Edit Mail Content</legend>
				<div class="margin-form">';
				
		$html .= '
					<div class="clear"></div>
				</div>
				<label>'.$this->l('You are now editing: '. strtoupper($_REQUEST['file'])).'</label>
				<div class="margin-form">';

				foreach ($languages as $language)
				{
                    $existing_file = stripslashes($this->_getMailFileContents( $language ) ) ;// ($xml ? stripslashes(htmlspecialchars($xml->body->{'paragraph_'.$language['id_lang']})) : '') ;
					$html .= '
					<div id="cpara_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
						<textarea class="' . $editortype . '" cols="120" rows="32" id="body_mail_'.$language['id_lang'].'" name="body_mail_'.$language['id_lang'].'">' . $existing_file . '</textarea>
					</div>';
				 }

				$html .= $this->displayFlags($languages, $defaultLanguage, $divLangName, 'cpara', true);
				
				$html .= '
					<div class="clear"></div>
				</div>
				<div class="clear pspace"></div>
				<div class="margin-form clear">
					<input type="submit" name="submitUpdate" value="'.$this->l(' &radic; Save the file and go back to the Template List ').'" class="button" />
					<p>
						<a href="#emailtemplatelist">&uArr; Go back to the Templates List <b>without</b> saving (changes <u>may be lost</u> if you select another file).</a>
					</p>
				</div>
			</fieldset>
		</form>';
        return $html ;
	}
    function _putMailFileContents( $lang )
    {
        if( !isset($_REQUEST['file']) )
        {
            return "" ;
        }
        $filename = $_REQUEST['file'] ;
        if( !$filename )
        {
            return "" ;
        }
        $contents = $_REQUEST['body_mail_' . $lang['id_lang']] ;
        $file = dirname(__FILE__) . "/../../mails/". $lang['iso_code'] . "/" . $filename ;
        file_put_contents( $file, $contents ) ;
    }
    function _getMailFileContents( $lang )
    {
        if( !isset($_REQUEST['file']) )
        {
            return "" ;
        }
        $filename = $_REQUEST['file'] ;
        if( !$filename )
        {
            return "" ;
        }

        $file = dirname(__FILE__) . "/../../mails/". $lang['iso_code'] . "/" . $filename ;
        $cotents = @file_get_contents( $file ) ;
        return $cotents ;
    }
}

?>